/*
 * gehl_rotate.c
 * žǽ
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "gehl_types.h"
#include "gehl_rotate.h"
#include "gehl_turnover.h"


/*
 * ľѤβž
 * ե꡼žϤޤ
 */

/*
 * RotateX_Y(GEHL_IMG *img);
 *
 * X --- color depth
 * Y --- degree
 */
static int
Rotate8(GEHL_IMG *img, int degree);

static int
Rotate8_90(GEHL_IMG *img);

static int
Rotate8_270(GEHL_IMG *img);

static int
Rotate24(GEHL_IMG *img, int degree);

static int
Rotate24_90(GEHL_IMG *img);

static int
Rotate24_270(GEHL_IMG *img);

/*
 * 㳰
 */
static int
Rotate_180(GEHL_IMG *img);


/*
 * ž
 *
 * :
 *   degree --- ײɽ(1-359)
 * :
 *   img --- 
 */
int
__GEHL_Rotate(GEHL_IMG *img, int degree)
{
    int ret = -1;


    if (NULL == img)
        return ret;

    degree %= 360;
    if (degree == 0)
        return -1;
    if (degree < 0)
        degree += 360;

    switch(img->bits) {

    case 1:
    case 8:
        ret = Rotate8(img, degree);
        break;

    case 24:
        ret = Rotate24(img, degree);
        break;
    }

    return ret;
}

static int
Rotate8(GEHL_IMG *img, int degree)
{
    int ret = -1;

    switch (degree) {

    case 0:
        break;

    case 90:
        ret = Rotate8_90(img);
        break;

    case 180:
        ret = Rotate_180(img);
        break;

    case 270:
        ret = Rotate8_270(img);
        break;

    default:
        break;
    }

    return ret;
}

static int
Rotate8_90(GEHL_IMG *img)
{
    int x, y;
    int rb_dest;
    char *buf, *pbuf, *src, *psrc, *dest, *pdest;
    char *img_dest;
    int h_dest, w_dest;

    /* ХåեѰդ */
    rb_dest = ((img->height + 3) / 4) * 4;
    pbuf = (char *)malloc(rb_dest + 8); /* ǰΤޡȤ */
    if (NULL == pbuf)
        return -1;
    memset(pbuf, 0, rb_dest + 8);

    /* 񤭽ФѥѰդ */
    w_dest = img->height;
    h_dest = img->width;
    img_dest = (char *)malloc(rb_dest * h_dest);
    if (NULL == img_dest) {
        free(pbuf);
        return -1;
    }
    memset(img_dest, 0, rb_dest * h_dest);

    psrc = img->pdata + (img->rowbytes *(img->height - 1));
    pdest = img_dest;
    buf = pbuf;

    for (y = 0; y < h_dest; y++) {
        src = psrc + y;
        dest = pdest + y * rb_dest;
        buf = pbuf;
        for (x = 0; x < w_dest; x++, src -= img->rowbytes) {
            buf[x] = *src;
        }
        memmove(dest, pbuf, rb_dest);
    }

    img->pdata = (char *)realloc(img->pdata, rb_dest * h_dest);
    if (NULL == img->pdata) {
        free(img_dest);
        free(pbuf);
        return -1;
    }

    memmove(img->pdata, img_dest, rb_dest * h_dest);
    img->width = w_dest;
    img->height = h_dest;
    img->rowbytes = rb_dest;

    free(img_dest);
    free(pbuf);

    return 0;
}

static int
Rotate8_270(GEHL_IMG *img)
{
    int ret = -1;

    ret = Rotate8_90(img);
    if (ret) return ret;

    return Rotate_180(img);
}

static int
Rotate24(GEHL_IMG *img, int degree)
{
    int ret = -1;

    switch (degree) {

    case 0:
        break;

    case 90:
        ret = Rotate24_90(img);
        break;

    case 180:
        ret = Rotate_180(img);
        break;

    case 270:
        ret = Rotate24_270(img);
        break;

    default:
        break;
    }

    return ret;
}

static int
Rotate24_90(GEHL_IMG *img)
{
    int x, y;
    char *pbuf, *src, *psrc, *dest, *pdest;
    char *img_dest;
    int h_dest, w_dest, imgsize;

    h_dest = img->width;
    w_dest = img->height;
    imgsize = h_dest * w_dest;

    /* Хåեmalloc */
    pbuf = (char *)malloc(w_dest);
    if (NULL == pbuf) return -1;
    memset(pbuf, 0, w_dest);

    /* 񤭽Фѥmalloc */
    img_dest = (char *)malloc(3 * imgsize);
    if (NULL == img_dest) {
        free(pbuf);
        return -1;
    }
    memset(img_dest, 0, 3 * imgsize);

    /* Redž */
    src = img->pred + img->width * (img->height - 1);
    dest = img_dest;
    for (y = 0; y < h_dest; y++) {
        psrc = src + y;
        pdest = dest + y * w_dest;
        for (x = 0; x < w_dest; x++, psrc -= img->width) {
            pbuf[x] = *psrc;
        }
        memmove(pdest, pbuf, w_dest);
    }

    /* greenž */
    src = img->pgreen + img->width * (img->height - 1);
    dest = img_dest + imgsize;
    for (y = 0; y < h_dest; y++) {
        psrc = src + y;
        pdest = dest + y * w_dest;
        for (x = 0; x < w_dest; x++, psrc -= img->width) {
            pbuf[x] = *psrc;
        }
        memmove(pdest, pbuf, w_dest);
    }

    /* bluež */
    src = img->pblue + img->width * (img->height - 1);
    dest = img_dest + 2 * imgsize;
    for (y = 0; y < h_dest; y++) {
        psrc = src + y;
        pdest = dest + y * w_dest;
        for (x = 0; x < w_dest; x++, psrc -= img->width) {
            pbuf[x] = *psrc;
        }
        memmove(pdest, pbuf, w_dest);
    }

    memmove(img->pdata, img_dest, 3 * imgsize);

    img->width = img->rowbytes = w_dest;
    img->height = h_dest;

    free(img_dest);
    free(pbuf);

    return 0;
}

static int
Rotate24_270(GEHL_IMG *img)
{
    int ret = -1;

    ret = Rotate24_90(img);
    if (ret) return ret;

    return Rotate_180(img);
}

/*
 * 180žؿ
 * ݤʤΤ
 * ȿžؿȤޤ魯...
 */
static int
Rotate_180(GEHL_IMG *img)
{
    int ret = -1;

    ret = __GEHL_Turnover(img, HORIZONTAL);
    if (!ret) ret = __GEHL_Turnover(img, VERTICAL);

    return ret;
}
